require "wowhead_helper"
class WoWHeadRecipes
  include JsonHelper
  include WoWHeadHelper
  def initialize()
    @@alchemy = Hash.new
    @@blacksmithing = Hash.new
    @@enchanting = Hash.new
    @@engineering = Hash.new
    @@inscription = Hash.new
    @@jewelcrafting = Hash.new
    @@leatherworking = Hash.new
    @@tailoring = Hash.new
    @@first_aid = Hash.new
    @@mining = Hash.new
    @@specialities = Hash.new
    @@cooking = Hash.new
  end
=begin rdoc
  Get a list of all smelting recipes
  returns
    a Hash keys by receip name
=end
  def get_cooking_list
    if @@cooking.length == 0
      map = browse_spells("9.185")
      cleanup_list(map[:data],@@cooking)
    end
    return @@cooking
  end
=begin rdoc
  Get a list of all smelting recipes
  returns
    a Hash keys by receip name
=end
  def get_mining_list
    if @@mining.length == 0
      map = browse_spells("11.186")
      cleanup_list(map[:data],@@mining)
    end
    return @@mining
  end
=begin rdoc
  Get a list of All first aid recipes
  returns
    a Hash keyed by recipe name
=end
  def get_firstaid_list
    if @@first_aid.length == 0
      map = browse_spells("9.129")
      cleanup_list(map[:data],@@first_aid)
    end
    return @@first_aid    
  end
=begin rdoc
  Get a list of all Alchemy Receipes
  returns 
    a Hash keyed by recipe name
=end
  def get_alchemy_list
    if @@alchemy.length == 0
      map = browse_spells("11.171")
      cleanup_list(map[:data],@@alchemy)
    end
    return @@alchemy
  end
=begin rdoc
  Get a list of all Blacksmithing Receipes
  returns 
    a Hash keyed by recipe name
=end
  def get_blacksmithing_list
    if @@blacksmithing.length == 0
      map = browse_spells("11.164")
      cleanup_list(map[:data],@@blacksmithing)
    end
    return @@blacksmithing
  end
=begin rdoc
  Get a list of all Enchanting Receipes
  returns: a hash keyed by recipe name
=end
  def get_enchanting_list
    if @@enchanting.length == 0
      map = browse_spells("11.333")
      cleanup_map(map[:data],@@enchanting)
    end
    return @@enchanting
  end
=begin rdoc
  Get a list of all Engineering Receipes
  returns: a hash keyed by recipe name
=end  
  def get_engineering_list
    if @@engineering.length == 0
      map = browse_spells("11.202")
      cleanup_list(map[:data],@@engineering)
    end
    return @@engineering
  end
=begin rdoc
  Get a list of all Inscription Receipes
  returns: a hash keyed by recipe name
=end
  def get_inscription_list
    if @@inscription.length == 0
      map = browse_spells("11.773")
      cleanup_list(map[:data],@@inscription)
    end
    return @@inscription
  end
=begin rdoc
  Get a list of all Jewelcrafting Receipes
  returns: a hash keyed by recipe name
=end  
  def get_jewelcrafting_list
    if @@jewelcrafting.length == 0
      map = browse_spells("11.755")
      cleanup_list(map[:data],@@jewelcrafting)
    end
    return @@jewelcrafting
  end
=begin rdoc
  Get a list of all Leatherworking Receipes
  returns: a hash keyed by recipe name
=end  
  def get_leatherworking_list
    if @@leatherworking.length == 0
      map = browse_spells("11.165")
      cleanup_list(map[:data],@@leatherworking)
    end
    return @@leatherworking
  end
=begin rdoc
  Get a list of all Tailoring Receipes
  returns: a hash keyed by recipe name
=end  
  def get_tailoring_list
    if @@tailoring.length == 0
      map = browse_spells("11.197")
      cleanup_list(map[:data],@@tailoring)
    end
    return @@tailoring
  end
=begin rdoc
  Get the name of a speciality for a given profession
  params: 
    skill
        Profession name that has a speciality  [Alchemy,Tailoring,Engineering,Blacksmithing,Leatherworking]
    id
        The speciality spell id, as provided in the recipe object after an add_recipe_details call.
  returns: the speciality skill name
=end
  def get_speciality(skill,id)
    if skill.eql?("Alchemy")
      get_alchemy_list
    elsif skill.eql?("Tailoring")
      get_tailoring_list
    elsif skill.eql?("Engineering")
      get_engineering_list
    elsif skill.eql?("Blacksmithing")
      get_blacksmithing_list
    elsif skill.eql?("Leatherworking")
      get_leatherworking_list
    else
      raise "Alchemy,Tailoring,Engineering,Blacksmithing,Leatherworking are the only Professions with a Speciality"
    end
    return @@specialities[id]
  end

=begin
  Cleanup our data for a common output format
=end  
  def cleanup_list(srcMap,dstMap)
    srcMap.each do |src|
      #puts "SRC: #{src.inspect}"
      src.delete(:cat)
      src.delete(:level)
      src.delete(:school)
      src[:skillups] = src[:colors]
      src.delete(:colors)
      src[:learned] = src[:learnedat]
      src.delete(:learnedat)
      src[:produces] = src[:creates]
      src.delete(:creates)
      method = src[:source]
      src.delete(:source)
      unless src[:produces].nil? or src[:produces].length == 2
        src[:produces].uniq!
      end
      if src[:produces] and src[:produces].length == 2 and src[:produces][1] == 1
        src[:produces] = [src[:produces][0]]
      end
      cname = nil
      if src[:name][0,1] != '@'
        name = src[:name]
        src[:rarity] = 7 - name[0,1].to_i
        name[0] = " "
        name.strip!
        cname = name
        dstMap[name] = src
        dstMap[name].delete(:name)
      else
        name = src[:name]
        name[0] = " "
        name.strip!
        cname = name
      end
      # matseries are added ID = Mastery
      if src[:learned] == 9999 and cname and src[:produces].nil? and method and method == 4
        @@specialities[src[:id]] = cname
      end
    end
  end
end
